
<?php
use Firebase\JWT\TokenJWT;
require_once "modelo/Router.php";
require_once "modelo/Cargo.php";
require_once "modelo/Funcionario.php";
require_once "modelo/TokenJWT.php";

//Cria uma instância da classe Router
$router  = new Router();

// ROTA:   /cargos  
// MÉTODO: POST
$router->post('/cargos', function () {
  //recupera o header contendo o token de autorização
  $headers     = apache_request_headers();

  $tokenJWT    = new TokenJWT();
  //verifica se o token é valido ou não
  if ($tokenJWT->validarToken($headers) == true) {
    //recupera os dados enviados no corpo da requisição.
    $jsonRecebido = file_get_contents('php://input');

    $obj = json_decode($jsonRecebido);   //converte os dados em um objeto json.

    $cargo = new Cargo();   //cria uma instância de Usuario

    //faz o "set" dos dados dentro da classe.
    $cargo->setNomeCargo($obj->nomeCargo);

    //verifica se existe algum usuário com o mesmo email
    if ($cargo->cargoExiste() == false) {
      //executa o método create da classe Usuário
      //prepara o array resposta que será convertido em json
      $resposta['status'] = $cargo->create();
      $resposta['msg'] = 'cadastrado com sucesso';
      $resposta['dados'] = $cargo;
    } else {
      $resposta['status'] = false;
      $resposta['msg'] = 'já existe um cargo com o nome de: ' . $obj->nomeCargo;
      $resposta['dados'] = $cargo;
    }
  } else {
    $resposta['status'] = false;
    $resposta['msg'] = "Login inválido";
    $resposta['codigo'] = 401;
  }
  echo json_encode($resposta, JSON_INVALID_UTF8_IGNORE);
});

// ROTA:   /cargos  
// MÉTODO: GET
$router->get('/cargos', function () {
  //recupera o header contendo o token de autorização
  $headers     = apache_request_headers();

  $tokenJWT    = new TokenJWT();

  //verifica se o token é valido ou não
  if ($tokenJWT->validarToken($headers) == true) {
    //recupera os dados enviados no corpo da requisição.
    $cargo = new Cargo();   //cria uma instância de Usuario
    $arrayCargos = $cargo->read();

    $resposta['status'] = true;
    $resposta['msg'] = 'Executado com sucesso';
    $resposta['dados'] = $arrayCargos;
  } else {
    $resposta['status'] = false;
    $resposta['msg'] = "Login inválido";
    $resposta['codigo'] = 401;
  }
  echo json_encode($resposta, JSON_INVALID_UTF8_IGNORE);
});

// ROTA:   /cargos  
// MÉTODO: PUT
$router->put('/cargos/(\d+)', function ($idCargo) {
  //recupera o header contendo o token de autorização
  $headers     = apache_request_headers();

  $tokenJWT    = new TokenJWT();
  //verifica se o token é valido ou não
  if ($tokenJWT->validarToken($headers) == true) {
    //recupera os dados enviados no corpo da requisição.
    $jsonRecebido = file_get_contents('php://input');
    $obj = json_decode($jsonRecebido);   //converte os dados em um objeto json.

    $cargo = new Cargo();   //cria uma instância de Usuario
    $cargo->setIdCargo($idCargo);
    $cargo->setNomeCargo($obj->nomeCargo);


    $resposta['status'] = $cargo->update();
    $resposta['msg'] = 'Executado com sucesso';
    $resposta['dados'] = $cargo;
  } else {
    $resposta['status'] = false;
    $resposta['msg'] = "Login inválido";
    $resposta['codigo'] = 401;
  }
   echo json_encode($resposta, JSON_INVALID_UTF8_IGNORE);
});


// ROTA:   /cargos  
// MÉTODO: DELETE
$router->delete('/cargos/(\d+)', function ($idCargo) {
  //recupera o header contendo o token de autorização
  $headers     = apache_request_headers();

  $tokenJWT    = new TokenJWT();
  //verifica se o token é valido ou não
  if ($tokenJWT->validarToken($headers) == true) {
    //recupera os dados enviados no corpo da requisição.
    $jsonRecebido = file_get_contents('php://input');
    $obj = json_decode($jsonRecebido);   //converte os dados em um objeto json.

    $cargo = new Cargo();   //cria uma instância de Usuario
    $cargo->setIdCargo($idCargo);


    $resposta['status'] = $cargo->delete();;
    $resposta['msg'] = 'Executado com sucesso';
    $resposta['dados'] = $cargo;

  } else {
    $resposta['status'] = false;
    $resposta['msg'] = "Login inválido";
    $resposta['codigo'] = 401;
  }
  echo json_encode($resposta, JSON_INVALID_UTF8_IGNORE);
});



// ROTA:   /login  
// MÉTODO: POST
$router->post('/login', function () {
  $jsonRecebido = file_get_contents('php://input');
  $obj = json_decode($jsonRecebido);
  $u1 = new Funcionario();
  $u1->setEmail($obj->email);
  $u1->setSenha($obj->senha);
  $resposta = array();
  if ($u1->verificarUsuarioSenha() == true) {
    $tokenJWT = new TokenJWT();
    $novoToken = $tokenJWT->gerarToken(json_encode($u1,JSON_INVALID_UTF8_IGNORE));
    $resposta['status'] = true;
    $resposta['msg'] = "Login efetuado com sucesso";
    $resposta['token'] =  $novoToken;
    $resposta['funcionario'] = $u1;
  } else {
    $resposta['status'] = false;
    $resposta['msg'] = 'Usuário não logado';
    $resposta['codigo'] = 401;
  }
  echo json_encode($resposta, JSON_INVALID_UTF8_IGNORE);
});

// ROTA:   /funcionarios  
// MÉTODO: POST
$router->post('/funcionarios', function () {
  //recupera o header contendo o token de autorização
  $headers     = apache_request_headers();
  $tokenJWT    = new TokenJWT();
  //verifica se o token é valido ou não
  if ($tokenJWT->validarToken($headers) == true) {
    //recupera os dados enviados no corpo da requisição.
    $jsonRecebido = file_get_contents('php://input');

    $obj = json_decode($jsonRecebido);   //converte os dados em um objeto json.
    
    $funcionario = new Funcionario();   //cria uma instância de Usuario

    //faz o "set" dos dados dentro da classe.
    $funcionario->setNome($obj->nome);
    $funcionario->setEmail($obj->email);
    $funcionario->setSenha($obj->senha);
    $funcionario->setRecebeValeTransporte($obj->vt);

    $cargo = new Cargo();
    $cargo->setIdCargo($obj->idCargo);
    $funcionario->setCargo($cargo);

    //verifica se existe algum usuário com o mesmo email
    if ($funcionario->funcionarioExiste() == false) {
      //executa o método create da classe Usuário
      //prepara o array resposta que será convertido em json
      $resposta['status'] = $funcionario->create();
      $resposta['msg'] = 'cadastrado com sucesso';
      $resposta['dados'] = $funcionario;
    } else {
      $resposta['status'] = false;
      $resposta['msg'] = 'já existe um funcionario com o nome de: ' . $obj->nome;
      $resposta['dados'] = $funcionario;
    }  
  } else {
    $resposta['status'] = false;
    $resposta['msg'] = 'Usuário não logado';
    $resposta['codigo'] = 401;
  }
  echo json_encode($resposta, JSON_INVALID_UTF8_IGNORE);
});

// ROTA:   /funcionarios  
// MÉTODO: GET
$router->get('/funcionarios', function () {
  //recupera o header contendo o token de autorização
  $headers     = apache_request_headers();
  $tokenJWT = new TokenJWT();
  //verifica se o token é valido ou não
  if ($tokenJWT->validarToken($headers) == true) {
    $fucionario = new Funcionario();   //cria uma instância de Usuario

    $resposta['status'] = true;
    $resposta['msg'] = 'executado com sucesso';
    $resposta['dados'] = $fucionario->read();
  } else {
    $resposta['status'] = false;
    $resposta['msg'] = 'Usuário não logado';
    $resposta['codigo'] = 401;

  }
  echo json_encode($resposta, JSON_INVALID_UTF8_IGNORE);
});

// ROTA:   /funcionarios  
// MÉTODO: PUT
$router->put('/funcionarios/(\d+)', function ($idFuncionario) {

  //recupera o header contendo o token de autorização
  $headers     = apache_request_headers();
  $tokenJWT = new TokenJWT();
  //verifica se o token é valido ou não
  if ($tokenJWT->validarToken($headers) == true) {

    //recupera os dados enviados no corpo da requisição.
    $jsonRecebido = file_get_contents('php://input');
    $obj = json_decode($jsonRecebido);   //converte os dados em um objeto json.

    $funcionario = new Funcionario();   //cria uma instância de Usuario
    $funcionario->setIdFuncionario($idFuncionario);

    //faz o "set" dos dados dentro da classe.
    $funcionario->setNome($obj->nome);
    $funcionario->setEmail($obj->email);
    $funcionario->setSenha($obj->senha);
    $funcionario->setRecebeValeTransporte($obj->vt);

    $cargo = new Cargo();
    $cargo->setIdCargo($obj->idCargo);
    $funcionario->setCargo($cargo);

    $resposta['status'] = true;
    $resposta['msg'] = 'excluido com sucesso';
    $resposta['dados'] = $funcionario->update();
  } else {
    $resposta['status'] = false;
    $resposta['msg'] = 'Usuário não logado';
    $resposta['codigo'] = 401;
  }
  echo json_encode($resposta, JSON_INVALID_UTF8_IGNORE);
});

// ROTA:   /funcionarios  
// MÉTODO: DELETE
$router->delete('/funcionarios/(\d+)', function ($idFuncionario) {
  //recupera o header contendo o token de autorização
  $headers     = apache_request_headers();

  $tokenJWT = new TokenJWT();
  //verifica se o token é valido ou não
  if ($tokenJWT->validarToken($headers) == true) {
    $fucionario = new Funcionario();   //cria uma instância de Usuario
    $fucionario->setIdFuncionario($idFuncionario);
    $resposta['status'] = true;
    $resposta['msg'] = 'excluido com sucesso';
    $resposta['dados'] = $fucionario->delete();

  } else {
    $resposta['status'] = false;
    $resposta['msg'] = 'Usuário não logado';
    $resposta['codigo'] = 401;
 
  }
  echo json_encode($resposta, JSON_INVALID_UTF8_IGNORE);
});
$router->run();
